/***************************************************************************
 *   Copyright Brian Ledbetter 2001-2003 <brian@shadowcom.net>             *
 *   Copyright Ravikiran Rajagopal 2003                                    *
 *   ravi@ee.eng.ohio-state.edu                                            *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License (version 2) as   *
 *   published by the Free Software Foundation. (The original KSplash/ML   *
 *   codebase (upto version 0.95.3) is BSD-licensed.)                      *
 *                                                                         *
 ***************************************************************************/

#include <kcmdlineargs.h>
#include <kdebug.h>
#include <kwin.h>

#include <qevent.h>
#include <qwidget.h>

#include "objkstheme.h"
#include "themeengine.h"
#include "themeengine.moc"

ThemeEngine::ThemeEngine( QWidget *, const char *, const QStringList& args )
    : QVBox( 0, "wndSplash", WStyle_Customize|WStyle_StaysOnTop|WStyle_NoBorder )
{
  if (args.isEmpty())
    mTheme = new ObjKsTheme( "Default" );
  else
    mTheme = new ObjKsTheme( args.first() );
  mTheme->loadCmdLineArgs( KCmdLineArgs::parsedArgs() );

  KWin::setState( winId(), NET::StaysOnTop | NET::SkipTaskbar | NET::SkipPager );
}

void ThemeEngine::mouseReleaseEvent( QMouseEvent * )
{
  close( TRUE );
}
